QGIS Application - Bug report #3395
Field Calculator Integer Conversion Error
2011-01-06 06:00 AM - alexckp -

Status: Closed

Priority: Low

Assignee: Jurgen Fischer

Category: Vectors

Affected QGIS version:master Regression?: No

Operating System: All Easy fix?: No

Pull Request or Patch supplied: Resolution: fixed/implemented
Crashes QGIS or corrupls data: Copied to github as #: 13455
Description

| tried to use FC to extract an integer number using the following formula:
(SURV_BRG * 1000) - to int (to int(SURV_BRG * 100) * 10)
If the number is 62.233, the above formula will correctly return the number 3. However, when | encounter certain numbers, e.g. the

number 65.1, the result is 9.99999999999272 instead of 0. | think this has to do with the to int function not returning a true integer and
would appreciate if this problem could be solved.

History

#1 - 2011-04-16 07:16 AM - Anne Ghisla

| tried to reproduce the bug.

If | set the type of the new field as integer, the formula outputs 3 and 10 as expected.

If I set it as decimal, then | get the 9.99999.. even if the formula tries to output an integer.

Computing partial results in a new decimal field, with input value as 65.1, gives this:

SURV_BRG * 100 = 6510

to int(SURV_BRG ) = 65

to int(SURV_BRG * 100) = 6509

If affects Fedora, so changing platform to All.

#2 - 2011-12-16 01:50 PM - Giovanni Manghi

- Target version changed from Version 1.7.0 to Version 1.7.4

#3 - 2012-04-16 06:24 AM - Paolo Cavallini

- Crashes QGIS or corrupts data set to No

- Affected QGIS version set to master

- Target version changed from Version 1.7.4 to Version 1.8.0

#4 - 2012-09-04 12:03 PM - Paolo Cavallini
- Target version changed from Version 1.8.0 to Version 2.0.0
#5 - 2013-09-24 01:37 PM - Jiirgen Fischer
- Pull Request or Patch supplied set to No

- Subject changed from Field Calculator Integer Conversion Errror to Field Calculator Integer Conversion Error
#6 - 2014-06-02 04:59 AM - Nathan Woodrow

- Resolution set to fixed/implemented
- Status changed from Open to Closed

There is a new expression engine since 2.0 and this is no longer an issue.
